unit EGA;

{***************************************************************}
{		J U J U  . P A S       27.08.89                 }
{***************************************************************}

interface

{***************************************************************}
{ Type Definicion                                              	}
{***************************************************************}
type
   Maska32   = array[0..31] of integer;
   Pattern16 = array[0..15] of integer;
   KeyDef    = array[0..15] of byte;

{***************************************************************}
{ Procedures and Functions Definicion                           }
{***************************************************************}

function    init            ( mode : integer ) : integer;
procedure   finit           ;

procedure   erasescr        ( color : integer );
procedure   colmap          ( index, red, green, blue : integer );
procedure   defcolmap       ;
procedure   regcol	    ( index, rgbRGB : integer );
procedure   overregcol	    ( rgbRGB : integer );

procedure   logic           ( ltype : integer );
function    getscrlogic     : integer;
procedure   color           ( icol : integer );
function    getscrcolor     : integer;
function    Xar             ( xcoor : integer ) : integer;
function    Yar             ( ycoor : integer ) : integer;
procedure   windowoff       ;
procedure   windowXY        ( xoffset, yoffset, dx, dy : integer );

procedure   moveab          ( ix, iy : integer );
function    getXpos         : integer;
function    getYpos         : integer;

procedure   linestyle       ( pattern : integer );
procedure   linefirst       ( first : integer );
procedure   linepattern     ( pattern : integer );
procedure   lineXY          ( x1, y1, x2, y2 : integer );
procedure   lineabs         ( x1, y1, x2, y2 : integer );
procedure   linepos         ( x, y : integer );
procedure   lineab          ( ix, iy : integer );
procedure   lineh           ( xdis : integer );
procedure   linew           ( ydis : integer );
procedure   linef           ( xdis : integer );
procedure   linefw	    ( ydis : integer );
procedure   box             ( x, y : integer );
procedure   boxfill         ( x, y : integer );
procedure   boxcc           ( x, y, col1, col2 : integer );
procedure   barfill         ( x, y : integer );
procedure   fillstyle       ( pattern : Pattern16 );
procedure   fillbgcolor     ( color : integer );

procedure   setpattern      ( p : integer );
procedure   rectab          ( ix1, iy1, ix2, iy2 : integer );
procedure   recfill         ( ix1, iy1, ix2, iy2 : integer );

procedure   textout         ( stroka : string );
procedure   text8           ( x, y, col, bcol, patlog : integer; stroka : string );
procedure   patlog          ( bg_color, mode : integer );
procedure   setchar         ( pfar : pointer; rows, fontoffset : integer );
function    findfont        ( vdots, setreset : integer ) : pointer;
function    getvfont        : integer;
procedure   font14r         ;
procedure   font8r          ;

function    memblock        ( dx, dy : integer ) : longint;
procedure   rdblock	    ( x, y, width, height : integer; pfar : pointer );
procedure   wrblock	    ( x, y, width, height : integer; pfar : pointer );

function    memimage        ( dx, dy : integer ) : longint;
procedure   rdimage         ( x, y, width, height : integer; pfar : pointer );
procedure   wrimage         ( x, y, width, height : integer; pfar : pointer );

function    qmemimag        ( dx, dy : integer ) : word;
procedure   qrdimag         ( x, y, width, height : integer; pfar : pointer );
procedure   qwrimag         ( x, y : integer; pfar : pointer );

procedure   zoom2           ( xs, ys, dx, dy, xd, yd : integer );
procedure   zoom4           ( xs, ys, dx, dy, xd, yd : integer );
procedure   zoom4s          ( xs, ys, dx, dy, xd, yd : integer );
procedure   zoom8s          ( xs, ys, dx, dy, xd, yd : integer );
procedure   zoom8ss         ( xs, ys, dx, dy, ox, oy, xd, yd, color : integer );

procedure   setrwpage       ( ireadpage, iwritepage : integer );
procedure   setvpage        ( visualpage : integer );
procedure   setrplane       ( rplane : integer );
procedure   setwplane       ( wplane : integer );

procedure   wrpixel         ( x, y, color : integer );
function    rdpixel         ( x, y : integer ) : integer;

procedure   vrwait          ( counter : integer );

procedure   scroll          ( x, yso, ydi, width, height : integer );
procedure   scrollh	    ( xso, y, xdi, width, height : integer );
procedure   savblock        ( xs, ys, xd, yd, dx, dy : integer );

function    textread        ( x, y, c, bc, len : integer; stroka : string ) : integer;

procedure   vtext           ( x, y, mas, orient : integer; pfar : pointer );

procedure   screenwidth     ( width : integer );
procedure   screenpan       ( newx, newy : integer );

procedure   circleout       ( x, y, radius, flag : integer );
procedure   circleoutf      ( x, y, radius : integer );
procedure   circlemode      ( mode : integer );

{***************************************************************}

procedure   cursorXOR       ( x, y : integer );
procedure   cursorPUT       ( x, y : integer );
procedure   cursorPUToff    ;
procedure   cursor_color    ( color, colorBG : integer );
procedure   cursor_define   ( xoffset, yoffset : integer; pointc : Maska32 );

procedure   curwindowXY     ( var x, y : integer );
procedure   curwindow       ( xmin, ymin, xmax, ymax : integer );

{***************************************************************}

function    step	    ( k, mulizor, divizor : integer ) : integer;

{***************************************************************}

procedure   play            ( stroka : pointer );
procedure   playstop        ;
procedure   playcikl        ( c : integer );
procedure   playwait        ( w : integer );

{***************************************************************}

function    mouseon         ( COMport : integer ) : integer;
procedure   mouseoff        ;
procedure   mouseXY         ( var x, y : integer );
function    mouseK          : integer;
function    mousehit        : integer;
procedure   mousecall	    ( set_reset : integer; fpoint, point : pointer );
function    getident        : integer;

procedure   kbdclr          ;
procedure   kbddef          ( pointc : KeyDef );
function    kbdK            : integer;
function    kbdhit          : integer;
function    kbdlast         : integer;

{***************************************************************}

procedure   t_cursoron	    ( xpos, ypos : integer );
procedure   t_cursoroff	    ;
procedure   t_cur_color	    ( color : integer );

procedure   t_color	    ( color : integer );
procedure   t_bgcolor	    ( bgcolor : integer );
procedure   t_window	    ( xoff, yoff, dx, dy : integer );
function    t_getcolor	    : integer;
procedure   t_init	    ( color : integer );

procedure   t_scrollUP	    ;
procedure   t_scrollDOWN    ;
procedure   t_scrollLEFT    ;
procedure   t_scrollRIGHT   ;
procedure   t_delh	    ( y : integer );
procedure   t_delw	    ( x : integer );

procedure   t_char	    ( x, y : integer; chch : char );

procedure   t_string	    ( x, y : integer; stroka : string );

procedure   t_TTY	    ( chch : char );
procedure   t_gotoXY	    ( x, y : integer );
function    t_getXpos	    : integer;
function    t_getYpos	    : integer;
procedure   t_TTY_cur       ( set_reset : integer );

function    t_memimag       ( dx, dy : integer ) : longint;
procedure   t_rdimag	    ( pfar : pointer );
procedure   t_wrimag        ( pfar : pointer );

{***************************************************************}
{ Procedures and Functions                                      }
{***************************************************************}
implementation

{$L EGABARF 	.OBJ}
{$L EGABARFU	.OBJ}
{$L EGABLKR 	.OBJ}
{$L EGABLKW 	.OBJ}
{$L EGABOX  	.OBJ}
{$L EGABOXF 	.OBJ}
{$L EGACOLMA	.OBJ}
{$L EGACUR  	.OBJ}
{$L EGACURD 	.OBJ}
{$L EGACURX 	.OBJ}
{$L EGACWIN 	.OBJ}
{$L EGADCOL 	.OBJ}
{$L EGAERASE	.OBJ}
{$L EGAFONT 	.OBJ}
{$L EGAHSCR 	.OBJ}
{$L EGAIMAGE	.OBJ}
{$L EGAINI  	.OBJ}
{$L EGAL2   	.OBJ}
{$L EGAL4   	.OBJ}
{$L EGAL4S  	.OBJ}
{$L EGAL8S  	.OBJ}
{$L EGAL8SS 	.OBJ}
{$L EGALINE 	.OBJ}
{$L EGALINEF	.OBJ}
{$L EGALINEU	.OBJ}
{$L EGALINEW	.OBJ}
{$L EGAPAGE 	.OBJ}
{$L EGAPAN  	.OBJ}
{$L EGAPATT 	.OBJ}
{$L EGAPIXR 	.OBJ}
{$L EGAPIXW 	.OBJ}
{$L EGAPLANE	.OBJ}
{$L EGARECF 	.OBJ}
{$L EGARECT 	.OBJ}
{$L EGAROUND	.OBJ}
{$L EGAROUNF	.OBJ}
{$L EGASAVE 	.OBJ}
{$L EGASCROL	.OBJ}
{$L EGATEXT 	.OBJ}
{$L EGATEXT8	.OBJ}
{$L EGATREAD	.OBJ}
{$L EGAVFONT	.OBJ}
{$L EGABCC	.OBJ}
{$L EGAQIMAG	.OBJ}

{$L MOUSE   	.OBJ}

{$L PLAY    	.OBJ}

{$L STEP    	.OBJ}

{$L T_CHAR  	.OBJ}
{$L T_CUR   	.OBJ}
{$L T_HSCR  	.OBJ}
{$L T_INI   	.OBJ}
{$L T_STRING	.OBJ}
{$L T_TTY   	.OBJ}
{$L T_WSCR  	.OBJ}
{$L T_SAVE	.OBJ}

{$L FONT14R	.OBJ}
{$L FONT8R	.OBJ}

{***************************************************************}

function    init            ( mode : integer ) : integer; external;
procedure   finit           ; external;

procedure   erasescr        ( color : integer ); external;
procedure   colmap          ( index, red, green, blue : integer ); external;
procedure   defcolmap       ; external;
procedure   regcol	    ( index, rgbRGB : integer ); external;
procedure   overregcol	    ( rgbRGB : integer ); external;

procedure   logic           ( ltype : integer ); external;
function    getscrlogic     : integer; external;
procedure   color           ( icol : integer ); external;
function    getscrcolor     : integer; external;
function    Xar             ( xcoor : integer ) : integer; external;
function    Yar             ( ycoor : integer ) : integer; external;
procedure   windowoff       ; external;
procedure   windowXY        ( xoffset, yoffset, dx, dy : integer ); external;

procedure   moveab          ( ix, iy : integer ); external;
function    getXpos         : integer; external;
function    getYpos         : integer; external;

procedure   linestyle       ( pattern : integer ); external;
procedure   linefirst       ( first : integer ); external;
procedure   linepattern     ( pattern : integer ); external;
procedure   lineXY          ( x1, y1, x2, y2 : integer ); external;
procedure   lineabs         ( x1, y1, x2, y2 : integer ); external;
procedure   linepos         ( x, y : integer ); external;
procedure   lineab          ( ix, iy : integer ); external;
procedure   lineh           ( xdis : integer ); external;
procedure   linew           ( ydis : integer ); external;
procedure   linef           ( xdis : integer ); external;
procedure   linefw	    ( ydis : integer ); external;
procedure   box             ( x, y : integer ); external;
procedure   boxfill         ( x, y : integer ); external;
procedure   boxcc           ( x, y, col1, col2 : integer ); external;
procedure   barfill         ( x, y : integer ); external;
procedure   fillstyle       ( pattern : Pattern16 ); external;
procedure   fillbgcolor     ( color : integer ); external;

procedure   setpattern      ( p : integer ); external;
procedure   rectab          ( ix1, iy1, ix2, iy2 : integer ); external;
procedure   recfill         ( ix1, iy1, ix2, iy2 : integer ); external;

procedure   textout         ( stroka : string ); external;
procedure   text8           ( x, y, col, bcol, patlog : integer; stroka : string ); external;
procedure   patlog          ( bg_color, mode : integer ); external;
procedure   setchar         ( pfar : pointer; rows, fontoffset : integer ); external;
function    findfont        ( vdots, setreset : integer ) : pointer; external;
function    getvfont        : integer; external;
procedure   font14r         ; external;
procedure   font8r          ; external;

function    memblock        ( dx, dy : integer ) : longint; external;
procedure   rdblock	    ( x, y, width, height : integer; pfar : pointer ); external;
procedure   wrblock	    ( x, y, width, height : integer; pfar : pointer ); external;

function    memimage        ( dx, dy : integer ) : longint; external;
procedure   rdimage         ( x, y, width, height : integer; pfar : pointer ); external;
procedure   wrimage         ( x, y, width, height : integer; pfar : pointer ); external;

function    qmemimag        ( dx, dy : integer ) : word; external;
procedure   qrdimag         ( x, y, width, height : integer; pfar : pointer ); external;
procedure   qwrimag         ( x, y : integer; pfar : pointer ); external;

procedure   zoom2           ( xs, ys, dx, dy, xd, yd : integer ); external;
procedure   zoom4           ( xs, ys, dx, dy, xd, yd : integer ); external;
procedure   zoom4s          ( xs, ys, dx, dy, xd, yd : integer ); external;
procedure   zoom8s          ( xs, ys, dx, dy, xd, yd : integer ); external;
procedure   zoom8ss         ( xs, ys, dx, dy, ox, oy, xd, yd, color : integer ); external;

procedure   setrwpage       ( ireadpage, iwritepage : integer ); external;
procedure   setvpage        ( visualpage : integer ); external;
procedure   setrplane       ( rplane : integer ); external;
procedure   setwplane       ( wplane : integer ); external;

procedure   wrpixel         ( x, y, color : integer ); external;
function    rdpixel         ( x, y : integer ) : integer; external;

procedure   vrwait          ( counter : integer ); external;

procedure   scroll          ( x, yso, ydi, width, height : integer ); external;
procedure   scrollh	    ( xso, y, xdi, width, height : integer ); external;
procedure   savblock        ( xs, ys, xd, yd, dx, dy : integer ); external;

function    textread        ( x, y, c, bc, len : integer; stroka : string ) : integer; external;

procedure   vtext           ( x, y, mas, orient : integer; pfar : pointer ); external;

procedure   screenwidth     ( width : integer ); external;
procedure   screenpan       ( newx, newy : integer ); external;

procedure   circleout       ( x, y, radius, flag : integer ); external;
procedure   circleoutf      ( x, y, radius : integer ); external;
procedure   circlemode      ( mode : integer ); external;

{***************************************************************}

procedure   cursorXOR       ( x, y : integer ); external;
procedure   cursorPUT       ( x, y : integer ); external;
procedure   cursorPUToff    ; external;
procedure   cursor_color    ( color, colorBG : integer ); external;
procedure   cursor_define   ( xoffset, yoffset : integer; pointc : Maska32 ); external;

procedure   curwindowXY     ( var x, y : integer ); external;
procedure   curwindow       ( xmin, ymin, xmax, ymax : integer ); external;

{***************************************************************}

function    step	    ( k, mulizor, divizor : integer ) : integer; external;

{***************************************************************}

procedure   play            ( stroka : pointer ); external;
procedure   playstop        ; external;
procedure   playcikl        ( c : integer ); external;
procedure   playwait        ( w : integer ); external;

{***************************************************************}

function    mouseon         ( COMport : integer ) : integer; external;
procedure   mouseoff        ; external;
procedure   mouseXY         ( var x, y : integer ); external;
function    mouseK          : integer; external;
function    mousehit        : integer; external;
procedure   mousecall	    ( set_reset : integer; fpoint, point : pointer ); external;
function    getident        : integer; external;

procedure   kbdclr          ; external;
procedure   kbddef          ( pointc : KeyDef ); external;
function    kbdK            : integer; external;
function    kbdhit          : integer; external;
function    kbdlast         : integer; external;

{***************************************************************}

procedure   t_cursoron	    ( xpos, ypos : integer ); external;
procedure   t_cursoroff	    ; external;
procedure   t_cur_color	    ( color : integer ); external;

procedure   t_color	    ( color : integer ); external;
procedure   t_bgcolor	    ( bgcolor : integer ); external;
procedure   t_window	    ( xoff, yoff, dx, dy : integer ); external;
function    t_getcolor	    : integer; external;
procedure   t_init	    ( color : integer ); external;

procedure   t_scrollUP	    ; external;
procedure   t_scrollDOWN    ; external;
procedure   t_scrollLEFT    ; external;
procedure   t_scrollRIGHT   ; external;
procedure   t_delh	    ( y : integer ); external;
procedure   t_delw	    ( x : integer ); external;

procedure   t_char	    ( x, y : integer; chch : char ); external;

procedure   t_string	    ( x, y : integer; stroka : string ); external;

procedure   t_TTY	    ( chch : char ); external;
procedure   t_gotoXY	    ( x, y : integer ); external;
function    t_getXpos	    : integer; external;
function    t_getYpos	    : integer; external;
procedure   t_TTY_cur       ( set_reset : integer ); external;

function    t_memimag       ( dx, dy : integer ) : longint; external;
procedure   t_rdimag	    ( pfar : pointer ); external;
procedure   t_wrimag        ( pfar : pointer ); external;

{***************************************************************}
{ Local Variables                                               }
{***************************************************************}

procedure   __lineh__ ; external;
procedure   __linex__ ; external;
procedure   __cur_bg__ ; external;
procedure   __cur_col__ ; external;
procedure   __cur_mask__ ; external;
procedure   __cur_show__ ; external;
procedure   __cur_xoffset__ ; external;
procedure   __cur_yoffset__ ; external;
procedure   __WX__ ; external;
procedure   __WY__ ; external;
procedure   __WoffsetX__ ; external;
procedure   __WoffsetY__ ; external;
procedure   __Xaspect__ ; external;
procedure   __bmasks__ ; external;
procedure   __bytetab__ ; external;
procedure   __chbase__ ; external;
procedure   __chbases__ ; external;
procedure   __choffset__ ; external;
procedure   __color__ ; external;
procedure   __icpx__ ; external;
procedure   __icpy__ ; external;
procedure   __logic__ ; external;
procedure   __page_length__ ; external;
procedure   __palette__ ; external;
procedure   __rscreenbase__ ; external;
procedure   __scrwid__ ; external;
procedure   __t_WX__ ; external;
procedure   __t_WY__ ; external;
procedure   __t_WoffsetX__ ; external;
procedure   __t_WoffsetY__ ; external;
procedure   __t_bgcolor__ ; external;
procedure   __t_color__ ; external;
procedure   __t_curX__ ; external;
procedure   __t_curY__ ; external;
procedure   __t_offset__ ; external;
procedure   __vdots__ ; external;
procedure   __videomode__ ; external;
procedure   __waitr__ ; external;
procedure   __writemask__ ; external;
procedure   __wscreenbase__ ; external;
procedure   __linefirst__ ; external;
procedure   __linepatt__ ; external;
procedure   __pat_bg__ ; external;
procedure   __pattern__ ; external;

{***************************************************************}

end.
